/*
 * Copyright (c) Sergey P. Derevyago, 2023.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * http://www.boost.org/LICENSE_1_0.txt
 *
 */

#pragma once
#include <ders/config.hpp>
#include <ders/ptr.hpp>

namespace ders {

class latch : public deletable {
 public:
    virtual bool arrive_and_wait()=0;
    virtual void interrupt()=0;

    latch& operator=(const latch&)=delete;
};

un_ptr<latch> new_latch(mem_pool* mp, int cnt, void (*on_start)(void*)=0, void* arg=0);

}  // namespace ders
