/*
 * Copyright (c) Sergey P. Derevyago, 2023.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * http://www.boost.org/LICENSE_1_0.txt
 *
 */

#pragma once
#include <ders/config.hpp>

namespace ders {

namespace impl {

void perm_assert_func(const char* expr, const char* file, int line);

}  // namespace impl

}  // namespace ders

#define perm_assert(expr) ((expr) ? (void)0 : ders::impl::perm_assert_func(#expr, __FILE__, __LINE__))
