/*
 * Copyright (c) Sergey P. Derevyago, 2023.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * http://www.boost.org/LICENSE_1_0.txt
 *
 */

#include <ders/hash.hpp>

namespace ders {

size_t mem_hash(const void* ptr, int sz)
{
    size_t ret=0;
    int szr=sizeof(ret);

    for (int pos=0; pos<sz; pos+=szr) {
        size_t v=0;
        memcpy(&v, (const char*)ptr+pos, (sz-pos>szr) ? szr : sz-pos);
        
        ret=(ret<<1)^v;
    }

    return ret;
}

}  // namespace ders
