/*
 * Copyright (c) Sergey P. Derevyago, 2023.
 *
 * Distributed under the Boost Software License, Version 1.0.
 * http://www.boost.org/LICENSE_1_0.txt
 *
 */

#include <ders/tx_buf.hpp>
#include <string>
#include <stdio.h>

namespace {

using namespace std;
using namespace ders;

template<class T>
inline void via_string(text* t, T v)
{
    string s=to_string(v);
    *t+=strsz(s.data(), s.size());
}

}  // unnamed

namespace ders {

#define OP_PLUS(T)             \
tx_buf& tx_buf::operator+(T v) \
{                              \
    via_string(get(ut_), v);   \
    return *this;              \
}

OP_PLUS(int)
OP_PLUS(unsigned int)
OP_PLUS(long)
OP_PLUS(unsigned long)
OP_PLUS(long long)
OP_PLUS(unsigned long long)
#undef OP_PLUS

void tx_buf::append(const void* ptr)
{
    char buf[20];
    *ut_+=strsz(buf, buf+sprintf(buf, "%p", ptr));
}

}  // namespace ders
